// nclbxExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "nclbxExample.h"
#include "nclbxExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// to demonstrate what happens without the patch
// comment-out the following definition
//#define MOUSEPATCH


// //////////////////////////////
// include the mouse patch code
#include "mousepatch.cpp"
// //////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNclbxExampleDlg dialog

CNclbxExampleDlg::CNclbxExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNclbxExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNclbxExampleDlg)
	m_bEnable = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNclbxExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNclbxExampleDlg)
	DDX_Control(pDX, IDC_ENABLE, m_cEnable);
	DDX_Control(pDX, IDC_MESSAGE, m_message);
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNclbxExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CNclbxExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_NCLBUTTONUP()
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNclbxExampleDlg message handlers

BOOL CNclbxExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	StartWindowsHook();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNclbxExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNclbxExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNclbxExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNclbxExampleDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	StopWindowsHook();
}

void CNclbxExampleDlg::OnNcLButtonDown(UINT nHitTest, CPoint point) 
{
	m_message.SetWindowText((LPCTSTR) _T("WM_NCLBUTTONDOWN"));
	CDialog::OnNcLButtonDown(nHitTest, point);
} 

void CNclbxExampleDlg::OnNcLButtonUp(UINT nHitTest, CPoint point) 
{
	m_message.SetWindowText((LPCTSTR) _T("WM_NCLBUTTONUP"));
	CDialog::OnNcLButtonUp(nHitTest, point);
}

void CNclbxExampleDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_message.SetWindowText((LPCTSTR) _T("WM_LBUTTONDOWN"));
	CDialog::OnLButtonDown(nFlags, point);
}

void CNclbxExampleDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_message.SetWindowText((LPCTSTR) _T("WM_LBUTTONUP"));
	CDialog::OnLButtonUp(nFlags, point);
}

void CNclbxExampleDlg::OnClear() 
{
	m_message.SetWindowText((LPCTSTR) _T(" "));
}

void CNclbxExampleDlg::StartWindowsHook()
{
	if(hMHook != NULL)
		StopWindowsHook();

	// Install mouse message hook
	hMHook = SetWindowsHookEx(WH_MOUSE, MouseHookProc, AfxGetInstanceHandle(), AfxGetThread()->m_nThreadID);
}

void CNclbxExampleDlg::StopWindowsHook()
{
	// remove the hook
	if(hMHook != NULL)
		UnhookWindowsHookEx(hMHook);

	hMHook = NULL;
}

void CNclbxExampleDlg::OnEnable() 
{
	UpdateData(TRUE);
	if(m_bEnable == TRUE)
	{
		StartWindowsHook();

		if(hMHook != NULL)
			m_cEnable.SetWindowText((LPCTSTR) _T("Click here to disable the patch."));
	}
	else
	{
		StopWindowsHook();
		m_cEnable.SetWindowText((LPCTSTR) _T("Click here to enable the patch."));
	}
	UpdateData(FALSE);
}
